/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Interface.java to edit this template
 */
package com.jcg.conditionalmappingexample;

import java.util.List;
import java.util.stream.Collectors;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Mappings;
import org.mapstruct.Named;
import org.mapstruct.factory.Mappers;

/**
 *
 * @author omozegieaziegbe
 */
@Mapper
public interface OrderMapper {

    OrderMapper INSTANCE = Mappers.getMapper(OrderMapper.class);

    @Mappings({
        @Mapping(target = "items", source = "items", qualifiedByName = "nonConfidentialItems")
    })
    OrderDTO orderToOrderDTO(Order order);

    @Named("nonConfidentialItems")
    default List<ItemDTO> mapNonConfidentialItems(List<Item> items) {
        return items.stream()
                .filter(item -> !item.isConfidential())
                .map(this::itemToItemDTO)
                .collect(Collectors.toList());
    }

    ItemDTO itemToItemDTO(Item item);

}
